﻿using System.Collections;
using System.Collections.Generic;
using System.Text;
using UnityEngine;
using UnityEngine.Networking;

public class UpdateStock : MonoBehaviour
{

    private ProductReader oProductData;
    private UnityWebRequest UWR;

    private string putUrlBase;
    private string putUrl;
    private string jsonBody;

    private int ID;
    private int category;
    private string shortname;
    private string manufacturer;
    private float stock;
    private string price;


    void Start()
    {

        oProductData = this.gameObject.GetComponent<ProductReader>();
        putUrlBase = ".../catalog/Products";
    }

    public void updateStock()
    {
        oProductData.getProductAttributes(out ID, out category, out shortname, out manufacturer, out stock, out price);

        putUrl = putUrlBase + "(" + ID + ")";

        stock -= 2;
        makeJSON();
        Debug.Log(category);
        StartCoroutine("putOData");

    }


    IEnumerator putOData()
    {

        var request = new UnityWebRequest(putUrl, "PUT");

        byte[] bodyRaw = Encoding.UTF8.GetBytes(jsonBody);
        request.uploadHandler = (UploadHandler)new UploadHandlerRaw(bodyRaw);
        request.downloadHandler = (DownloadHandler)new DownloadHandlerBuffer();
        request.SetRequestHeader("Content-Type", "application/json;IEEE754Compatible=true");

        yield return request.SendWebRequest();

        Debug.Log("Status Code: " + request.responseCode);
        Debug.Log("ERROR: " + request.error);

        oProductData.decreaseStock();
        oProductData.SetText();

    }

    private void makeJSON()
    {
        jsonBody = "{\"ID\":" + ID + ",";
        jsonBody += "\"category\":" + category + ",";
        jsonBody += "\"shortname\":\"" + shortname + "\",";
        jsonBody += "\"manufacturer\":\"" + manufacturer + "\",";
        jsonBody += "\"price\":\"" + price + "\",";
        jsonBody += "\"stock\":\"" + stock + "\"}";

    }





}
